package com.raditha.megaupload;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;
import com.blogspot.pontoflutuante.MimeBodyPart;

/*
 * MegaUPload-J version 0.10
 * http://www.raditha.com
 *
 * Licence:
 * The contents of this file are subject to the Mozilla Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Initial Developer of the Original Code is
 *	    Daniel Cristiano Rocha <a href="dcrocha@uai.com.br">dcrocha@uai.com.br</a
 * Portions Created by Daniel are Copyright Daniel Christiano Rocha 2002-2003
 * Portions created by Raditha are Copyright (C) 2003
 * Raditha Dissanayake. All Rights Reserved.
 */

public class UploadServlet extends HttpServlet {
	//MIMEGuesser guesser = new MIMEGuesser();

	public void doPost(HttpServletRequest request,HttpServletResponse response)
		throws IOException,ServletException
	{
		HttpSession session = request.getSession();
		String sessId = session.getId();

		System.out.println("content length = " + request.getContentLength());

		PrintWriter out = response.getWriter();
		FileUpload fu = new FileUpload(request);

		fu.writeStats(0);
		response.setContentType("text/html");
		response.setHeader("Cache-control","no-cache");

		if(request.getContentLength() < 50000000)
		{
		    doUpload(out, fu);
		}
		else
		{
			out.println("Only 50  MB allowed");
		}

		out.println("</body></html>");

	}

	private void doUpload(PrintWriter out, FileUpload fu) {
		long tempo1 = new Date().getTime();
		boolean ok = fu.upload();


		out.println("<html><head><title>Testing File Upload Class</title></head>");
		out.println("<body>\n");

		if(!ok)	{
			out.println(fu.getErrString());
			}
		else {
			  HashMap m = fu.getMimeParts();
			  MimeBodyPart part = null;

			  for(int i=1; i < 11 ; i++)
			  {
				  out.println("<hr>");
				  part = (MimeBodyPart)m.get("file" + i);
				  /* you should not call getFileName() until file has been saved,
					 because it could get a machine-generated name and right now
					 you would be with a wrong fileName */
				  if(part != null)
				  {
					  out.println(part.getName() + "=" + part.getFileName());
					  out.println("File Size = " + part.getFileSize());
					  out.println("<br>");
					  boolean saved = part.saveFile();
					  if(!saved) out.println("<br>" + part.getErrString());
					  else {
						/* now is the correct time to call getFileName(); */
						out.println("<br> " + part.getName() + "=" + part.getFileName());
						out.println("<br>");
					  }

					  String path = getServletContext().getRealPath("/") + "upload/";
						/* new method for version 0.2 */
					  fu.setSaveDir(path);

						out.println("<hr>");
				  }
				  part = (MimeBodyPart)m.get("file" + i) ;
				}

				long tempo2 = new Date().getTime();
				out.println("It took " + (double)(tempo2 - tempo1)/1000 + " seconds to perform the upload.");

			}
	}
	public void doGet(HttpServletRequest request,HttpServletResponse response)
	throws IOException,ServletException {
	    PrintWriter out = response.getWriter();
		out.println("NO GET SUPPORT");
	}
}
