package com.raditha.megaupload;

import java.io.*;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.ServletException;

public class MultipartIterator extends org.apache.struts.upload.MultipartIterator{
	long progress;
	int i=0;

    public MultipartIterator(HttpServletRequest request,
                             int bufferSize,
                             long maxSize,
                             String tempDir) throws ServletException
	{
		super(request,bufferSize,maxSize,tempDir);
	}

    /**
     * Creates a file on disk from the current mulitpart element
     * @param fileName the name of the multipart file
     */
    protected File createLocalFile() throws IOException {

        File tempFile = File.createTempFile("strts", null, new File(tempDir));
        BufferedOutputStream fos = new BufferedOutputStream(new FileOutputStream(tempFile),
                                                            diskBufferSize);
        byte[] lineBuffer = inputStream.readLine();
        if (lineBuffer == null)
        {
            throw new IOException("Premature end of stream while reading multipart request");
        }
	    int bytesRead = lineBuffer.length;
		progress =+ bytesRead;

        boolean cutCarriage = false;
        boolean cutNewline = false;

        try {
            while ((bytesRead != -1) && (!equals(lineBuffer, 0, boundaryBytes.length,
                    boundaryBytes))) {

                        if (cutCarriage) {
                            fos.write('\r');
                        }
                        if (cutNewline) {
                            fos.write('\n');
                        }
                        cutCarriage = false;
                        if (bytesRead > 0) {
                            if (lineBuffer[bytesRead-1] == '\r') {
                                bytesRead--;
                                cutCarriage = true;
								progress++;
                            }
                        }
                        cutNewline = true;
                        fos.write(lineBuffer, 0, bytesRead);
                        lineBuffer = inputStream.readLine();
                        if (lineBuffer == null)
                        {
                            throw new IOException("Premature end of stream while reading multipart request");
                        }
                        bytesRead = lineBuffer.length;
						progress += bytesRead;
						writeStats(progress);
            }
			writeStats(contentLength);
        }
        catch (IOException ioe) {
            fos.close();
            tempFile.delete();
            throw ioe;
        }

        fos.flush();
        fos.close();
        return tempFile;
    }



    /**
     * Reads the input stream until it reaches a new line
     */
    protected String readLine() throws ServletException, UnsupportedEncodingException {

        byte[] bufferByte;
        int bytesRead;

        if (totalLength >= contentLength) {
            return null;
        }

        try {
            bufferByte = inputStream.readLine();
            if (bufferByte == null)
                return null;
            bytesRead  = bufferByte.length;
			progress += bytesRead;

        }
        catch (IOException ioe) {
            throw new ServletException("IOException while reading multipart request: " +
				       ioe.getMessage());
        }
        if (bytesRead == -1) {
            return null;
        }

        totalLength += bytesRead;
        return new String(bufferByte, 0, bytesRead, "ISO-8859-1");
    }



	public void writeStats(long bytesRead) throws IOException {

			PrintWriter statWriter = new PrintWriter(new FileWriter("/tmp/" +request.getSession().getId()));
			System.out.println("/tmp/" +request.getSession().getId());
			statWriter.println(request.getContentLength());
			statWriter.println(bytesRead);
			statWriter.flush();
			statWriter.close();
			Thread.yield();
			/* sleep now and then so that the progress bar can be read */
		    if(i==16)
			{
				try {
					Thread.sleep(50);
				}
				catch (InterruptedException ex) {
				}
				i=0;
			}
			i++;

	}

}
